import * as tailwind_factory_dist from 'tailwind-factory/dist';
import * as react from 'react';
import { ComponentProps } from 'react';
import { PrismTheme, Language } from 'prism-react-renderer';

declare const HighlightContainer: ((props: react.ClassAttributes<HTMLDivElement> & react.HTMLAttributes<HTMLDivElement> & Partial<tailwind_factory_dist.FactoryExtractKeys<{
    full: {
        true: string;
        false: string;
    };
}>> & Required<Omit<tailwind_factory_dist.FactoryExtractKeys<{
    full: {
        true: string;
        false: string;
    };
}>, "full">>) => JSX.Element) & {
    __extends: <NewType extends tailwind_factory_dist.FactoryElement | null, NewStyleVariants, NewDefaultStyleVariants, NewDefaultStyleVariantsScheme extends tailwind_factory_dist.FactoryExtractKeys<tailwind_factory_dist.FactoryExtractRequiredKeysAndValues<{
        full: {
            true: string;
            false: string;
        };
    }> & NewStyleVariants>>(newElement?: NewType | undefined, newStyles?: string | undefined, newConfig?: tailwind_factory_dist.StyledElementOptions<NewStyleVariants & tailwind_factory_dist.FactoryExtractKeysAndValues<{
        full: {
            true: string;
            false: string;
        };
    }>, NewDefaultStyleVariants, NewDefaultStyleVariantsScheme> | undefined) => ((props: (NewType extends tailwind_factory_dist.FactoryElement ? react.ComponentProps<NewType> : react.DetailedHTMLProps<react.HTMLAttributes<HTMLDivElement>, HTMLDivElement>) & (NewDefaultStyleVariants extends infer C_1 ? Partial<{
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1 ? tailwind_factory_dist.FactoryExtractKeys<U_1> : any> & Required<Omit<{
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1_1 ? tailwind_factory_dist.FactoryExtractKeys<U_1_1> : any, "full" | keyof C_1>> : {
        full: {
            true: string;
            false: string;
        };
    } & NewStyleVariants extends infer U_1_2 ? tailwind_factory_dist.FactoryExtractKeys<U_1_2> : any)) => JSX.Element) & {
        __extends: any;
    };
};

declare const tokens: readonly ["char", "class-name", "function", "mayble-class-name", "method", "function-variable", "variable", "attr-name", "punctuation", "operator", "markup", "tag", "atrule", "deleted", "selector", "string", "attr-value", "template-punctuation", "constant", "number", "builtin", "changed", "keyword", "interpolation-punctuation", "comment", "inserted", "prolog", String];

interface HighlightTheme extends Omit<PrismTheme, "styles"> {
    plain: PrismTheme["plain"] & {
        numbersColor?: string;
        numbersBackgroundColor?: string;
        numbersBorderColor?: string;
        srollbarThumbColor?: string;
        scrollbarTrackColor?: string;
    };
    styles: {
        types: (typeof tokens)[number][];
        style: PrismTheme["styles"][number]["style"];
        languages?: Language[];
    }[];
}

declare const themes: {
    primary: HighlightTheme;
    dracula: HighlightTheme;
    duotoneDark: HighlightTheme;
    duotoneLight: HighlightTheme;
    github: HighlightTheme;
    nightOwl: HighlightTheme;
    nightOwlLight: HighlightTheme;
    oceanicNext: HighlightTheme;
    palenight: HighlightTheme;
    okaidia: HighlightTheme;
    shadesOfPurple: HighlightTheme;
    synthwave84: HighlightTheme;
    ultramin: HighlightTheme;
    vsDark: HighlightTheme;
    vsLight: HighlightTheme;
};

declare const languages: readonly ["markup", "html", "bash", "clike", "c", "cpp", "css", "css-extras", "javascript", "jsx", "js-extras", "js-templates", "coffeescript", "diff", "git", "go", "graphql", "markup-templating", "handlebars", "json", "less", "makefile", "markdown", "objectivec", "ocaml", "python", "reason", "sass", "scss", "sql", "stylus", "tsx", "typescript", "wasm", "yaml", String];
declare function createLanguagePlugin(object: object): object;

declare class HighligthPlugin {
}

type HighlightSupportedLanguages = (typeof languages)[number];
type DefaultHighlightTheme = keyof typeof themes;

interface HighlightProps extends ComponentProps<typeof HighlightContainer> {
    children: string;
    theme?: DefaultHighlightTheme | HighlightTheme;
    language?: HighlightSupportedLanguages;
    showNumbers?: boolean;
    showNumbersBorder?: boolean;
    numbersContainerClassName?: string;
    numbersClassName?: string;
    plugins?: HighligthPlugin[];
}

declare function Highlight({ children, theme, language, showNumbers, showNumbersBorder, numbersContainerClassName, numbersClassName, plugins, ...rest }: HighlightProps): JSX.Element;

export { DefaultHighlightTheme, HighlightProps, HighlightSupportedLanguages, HighlightTheme, createLanguagePlugin, Highlight as default, themes };
